﻿#Region "FileHeader"
#If False Then
Sub New richtet das Form ein, das sind verschiedenste Sachen, ich gehe mal durch:
Me.AlignOnScreen(ContentAlignment.TopCenter)                - klebt das Form oben an den Screen
Dts.Canvas = Me.Canvas                                - gibt dem Dataset das Canvas, und lagert so die gesamte Grafik-Logik dahin aus.
Dts.Register(Me, False).Fill()                     - aktiviert auf diesem Form Dataset-Zusatz-Funktionenalität und befüllts auch gleich
Dts.RegisterCurrency(bsLayerFigureGrip, bsLayer, bsLayerFigure)   - synchronisiert die 3 BindingSources mit dem Dataset-Current-Tracking
ControlStyling.StyleControls(Me)                                  - stylet alle DGVs dieses Forms auf einheitliche Weise
CanvasMenu.Enabled = False                      - disabled das Contextmenü mit allen Items - kann man leider nicht im Designer erledigen, wg. Bug
AddHandler Dts.GripHover.ItemChanged, Sub(s, e) CanvasMenu.Enabled = Dts.GripHover.Item.NotNull    - enabled das Contextmenü beim Hovern eines Grips
dgvAllGrips.Attach.HierarchicalSort.DrawGroupLines() - richtet dgvAllGrips ein mit mehrstufiger Sortierung und Visualisierung von Gruppierungen

#End If '-- Options, Imports
Option Strict Off

Imports AdvancedPainting.FigureDts
#End Region 'FileHeader

Public Class frmAdvancedPainting

   Public Sub New()
      InitializeComponent()
      Me.AlignOnScreen(ContentAlignment.TopCenter)
      Dts.Register(Me, False).Fill()
      Dts.Canvas = Me.Canvas
      Dts.RegisterCurrency(bsLayerFigureGrip, bsLayer, bsLayerFigure)
      ControlStyling.StyleControls(Me)
      AddHandler Dts.GripHover.ItemChanged, Sub(s, e) CanvasMenu.Enabled = Dts.GripHover.Item.NotNull
      CanvasMenu.Enabled = False
      dgvAllGrips.Attach.HierarchicalSort.DrawGroupLines()
      dgvAllGrips_Sorted(Nothing, Nothing)
   End Sub

   Private Sub MenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) _
         Handles btReload.Click, btSave.Click, btTest.Click, btTest2.Click, btAddGrip.Click, btDeleteGrip.Click
      Select Case True
         Case sender Is btReload : Dts.Fill()

         Case sender Is btSave : Dts.Save(Me)

         Case sender Is btTest

         Case sender Is btAddGrip : Dts.GripHover.Item.FigureRow.AddGrip()

         Case sender Is btDeleteGrip : Dts.GripHover.Item.Delete()

         Case sender Is btTest2

      End Select
   End Sub

   Private Sub dgvFigure_CellContentClick(sender As Object, e As DataGridViewCellEventArgs) Handles dgvFigure.CellContentClick
      'bei Klick in die clmColor-Column mit ColorDialog die Figure-Color eingeben
      If dgvFigure.Columns(e.ColumnIndex) IsNot clmColor Then Return
      Dim fig = bsLayerFigure.At(Of FigureRow)()
      dlgColor.Color = fig.Color
      If dlgColor.ShowDialog(Me) = Windows.Forms.DialogResult.OK Then fig.Color = dlgColor.Color
   End Sub

   Private Sub dgvAllGrips_Sorted(sender As Object, e As EventArgs) Handles dgvAllGrips.Sorted
      'Sort-Property des zugrundeliegenden DataViews aufbereiten und anzeigen
      lbSort.Text = String.Concat(DirectCast(bsAllGrips.List, DataView).Sort.Split({"["c, "]"c}))
   End Sub

End Class