﻿Imports System.Runtime.CompilerServices
Imports System.Text
Imports System.ComponentModel
Imports System.Text.RegularExpressions
Imports System.IO
Imports System.Data.Common

Public Module LocalExtensionX

   <Extension()> _
   Public Sub EnsureExistUnique(Of T As DataRow)(ByRef row As T, ParamArray keyCols() As DataColumn)
      Dim tbl = DirectCast(row.Table, TypedTableBase(Of T))
      Dim rw = row
      If keyCols.Length = 0 Then keyCols = tbl.PrimaryKey
      Dim keyVals = (From col In keyCols Select col, val = rw(col)).ToArray
      rw = tbl.All.FirstOrDefault(Function(rw2) keyVals.All(Function(pv) rw2(pv.col).Equals(pv.val)))
      If rw.Null Then
         tbl.Rows.Add(row)
         If keyCols.Any(Function(clm) clm.AutoIncrement) Then row.AcceptChanges()
      Else
         row.Be(rw)
      End If
   End Sub

End Module