﻿Imports DbGenerator.DbGeneratorDts

Public Class dlgMapping
   Public Sub New()
      InitializeComponent()
      AddHandler MappingBindingSource.CurrentChanged, AddressOf MappingBindingSource_CurrentChanged
   End Sub

   Private Sub MappingBindingSource_CurrentChanged(sender As Object, e As EventArgs)
      If Not TypeOf MappingBindingSource.DataSource Is DataRowView Then Return
      RemoveHandler MappingBindingSource.CurrentChanged, AddressOf MappingBindingSource_CurrentChanged
      Dim mp = MappingBindingSource.At(Of MappingRow)()
      srcProvider.MoveTo(mp.ProviderRow)
      srcCmbDbName.MoveTo(mp.ID)
      srcCmbDbName_CurrentChanged(Nothing, Nothing)
      AddHandler srcCmbDbName.CurrentChanged, AddressOf srcCmbDbName_CurrentChanged
   End Sub

#If False Then
old fashioned reading and backwriting of values - no databinding. This because the Combo blits Default-Values into the Controls, which may be edited there.
in real Databinding editing would affect the combos DataSource
#End If
   Private Sub srcCmbDbName_CurrentChanged(sender As Object, e As EventArgs)
      With srcCmbDbName.At(Of MappingRow)()
         txtColumnSize.Text = .ColumnSize
         txtParamNames.Text = .ParamNames
         ParamDefaultValuesTextBox.Enabled = .ParamNames <> ""
         ParamDefaultValuesTextBox.Text = .ParamDefaultValues
      End With
   End Sub

   Private Sub dlgMapping_FormClosed(sender As Object, e As FormClosedEventArgs) Handles Me.FormClosed
      If DialogResult <> Windows.Forms.DialogResult.OK Then Return
      With MappingBindingSource.At(Of MappingRow)()
         .DbName = srcCmbDbName.At(Of MappingRow)().DbName
         .ColumnSize = txtColumnSize.Text
         .ParamNames = txtParamNames.Text
         .ParamDefaultValues = ParamDefaultValuesTextBox.Text
      End With
   End Sub
End Class