
#Region "FileHeader"
#If False Then
jdkwei
#End If '-- Options, Imports
#End Region 'FileHeader


Imports System
Imports System.Diagnostics
Imports System.Runtime.CompilerServices

Namespace System
   Public Class NotifyEventArgs(Of T) : Inherits EventArgs
      Public ReadOnly Value As T
      Public Sub New(Value As T)
         MyBase.New()
         Me.Value = Value
      End Sub
   End Class 'NotifyEventArgs(Of T)

   Public Delegate Sub EventHandlerEx(Of T0, T1 As EventArgs)(Sender As T0, e As T1)

   Public Delegate Sub EventHandlerEx(Of T0)(Sender As T0)

   Public Module modHelpers

      <DebuggerStepThrough()> _
      Public Sub Nop()
      End Sub
      <DebuggerStepThrough()> _
      Public Sub Nop(Of T)(arg As T)
      End Sub
      <DebuggerStepThrough()> _
      Public Sub Nop(Of T1, T2)(arg As T1, arg2 As T2)
      End Sub

      Public DebugDummi As Object
      Private _DbgID As Integer

      ''' <summary>einfache Debug-Ausgabe, nimmt alles, unkaputtbar</summary>
      Public Sub Dbg(Args As IEnumerable)
#If Not Debug Then
         Return
#End If
         Dim Args2 As New List(Of Object)
         Args2.Add(_DbgID)
         _DbgID = (_DbgID + 1) Mod 10
         For Each arg In Args
            Args2.Add(" ")
            Args2.Add(arg)
         Next
         Console.WriteLine(String.Concat(Args2))
      End Sub

      ''' <summary>einfache Debug-Ausgabe, nimmt alles, unkaputtbar</summary>
      Public Sub Dbg(Args As IList(Of Object))
#If Not Debug Then
         Return
#End If
         Dim Args2(Args.Count * 2) As Object
         Args2(0) = _DbgID & " "
         _DbgID = (_DbgID + 1) Mod 10
         For i As Integer = 0 To Args.Count - 1
            Args2(i * 2 + 1) = If(Args(i), "##-Null-##")
            Args2(i * 2 + 2) = " "
         Next
         Console.WriteLine(String.Concat(Args2))
      End Sub

      ''' <summary>einfache Debug-Ausgabe, nimmt alles, unkaputtbar</summary>
      Public Sub Dbg(ParamArray Args As Object())
         Dbg(DirectCast(Args, IList(Of Object)))
      End Sub
      Private _Args(-1) As Object
      Public Sub DbgChanges(ParamArray Args As Object())
         If Enumerable.SequenceEqual(Args, _Args) Then Return
         _Args = Args
         Dbg(DirectCast(Args, IList(Of Object)))
      End Sub

      ''' <summary>einfache Debug-Ausgabe, nimmt alles, unkaputtbar</summary>
      Public Sub Dbg(s As String)
#If Not Debug Then
         Return
#End If
         Console.WriteLine(String.Concat(_DbgID, " ", s))
         _DbgID = (_DbgID + 1) Mod 10
      End Sub

      Public Function Msg(msg1 As Object, ParamArray msgs() As Object) As Microsoft.VisualBasic.MsgBoxResult
         Dim strings = {msg1}.Concat(msgs).Select(Function(o) ReplaceBslashN(o.ToString))
         Return Microsoft.VisualBasic.MsgBox(String.Concat(strings))
      End Function

   End Module


End Namespace
