﻿Imports System.Data.Common
Imports DbGenerator.DbGeneratorDts

Partial Class DbGeneratorDts

   Partial Class ColumnMappingDataTable

      Private WithEvents _Active As ColumnMappingDataTable = Me
      Public ReadOnly EventDisabler As New ActionFrame(Sub() _Active = Nothing, Sub() _Active = Me)

      Private Sub _Active_ColumnChanged(sender As Object, e As DataColumnChangeEventArgs) Handles _Active.ColumnChanged
         If e.Row.RowState = DataRowState.Detached Then Return
         If e.Column IsNot MappingIDColumn Then Return
         Using EventDisabler.Enter
            Dim rw = DirectCast(e.Row, ColumnMappingRow)
            rw.ParamValues = rw.MappingRow.ParamDefaultValues
         End Using
      End Sub

   End Class 'ColumnMappingDataTable

   Partial Class ProviderRow

      Public Function GetMappingRowsValid() As MappingRow()
         With GetMappingRows()
            Return .Take(1, .Count - 1)
         End With
      End Function

   End Class 'ProviderRow

End Class