﻿Imports System.Windows.Forms

Namespace System.ComponentModel

   '''' <summary>System.ComponentModel.Component.DesignMode ist buggy</summary>
   Public Class MyDesignMode

      Private Function GetDesignMode() As Boolean
         Dim s = Application.ProductName
         'Msg(s)
         Return s.StartsWith("Microsoft® Visual Studio®")
      End Function

      Private _DesignMode As Boolean = GetDesignMode()

      Private Shared Singleton As New MyDesignMode

      Private Sub New()
         AddHandler Application.ApplicationExit, AddressOf ApplicationExit
      End Sub

      Private Sub ApplicationExit(Sender As Object, e As EventArgs)
         _DesignMode = True
      End Sub

      Public Shared ReadOnly Property [True]() As Boolean
         Get
            Return Singleton._DesignMode
         End Get
      End Property

      Public Shared ReadOnly Property [False]() As Boolean
         Get
            Return Not Singleton._DesignMode
         End Get
      End Property

   End Class 'MyDesignMode

End Namespace

