Imports System.IO
Imports Xml2SqlServerCe.PersonBerufDts
Imports System.Data.SqlServerCe

Public Class frmPersonBeruf

   Private _DataFile As New FileInfo("..\..\PersonBerufDts.Xml")

   Public Sub New()
      InitializeComponent()
      Dim adp = New DatasetAdapter( _
         SqlServerCe.SqlCeProviderFactory.Instance, _
         "Data Source=""..\..\SqlCe_FW4.sdf""".QuotedFullnamed, _
         Data.ConflictOption.OverwriteChanges)
      adp.InitRequery_ID(Sub(dtsAdapter, dataAdapter) AddHandler DirectCast(dataAdapter, SqlCeDataAdapter).RowUpdated, AddressOf dtsAdapter.RequeryID)
      PersonBerufDts.Adapter(adp).Register(Me, False)
   End Sub

   Private Sub MenuItem_Click(sender As Object, e As EventArgs) Handles TestToolStripMenuItem.Click, SaveXmlToolStripMenuItem.Click, FillXmlToolStripMenuItem.Click, SaveToDBToolStripMenuItem.Click, FillFromDBToolStripMenuItem.Click, berufNachPersonToolStripMenuItem.Click, personNachBerufToolStripMenuItem.Click
      Select Case True
         Case sender Is SaveXmlToolStripMenuItem : PersonBerufDts.WriteXml(_DataFile.FullName) : System.Media.SystemSounds.Asterisk.Play()
         Case sender Is FillXmlToolStripMenuItem : PersonBerufDts.Clear() : PersonBerufDts.ReadXml(_DataFile.FullName)
         Case sender Is SaveToDBToolStripMenuItem : PersonBerufDts.Save(Me)
         Case sender Is FillFromDBToolStripMenuItem : PersonBerufDts.Fill()
         Case sender Is berufNachPersonToolStripMenuItem : OutputBerufNachPerson()
         Case sender Is personNachBerufToolStripMenuItem : OutputPersonNachBeruf()
         Case sender Is TestToolStripMenuItem
            Dim rw = PersonBerufDts.Beruf(0)
            rw = PersonBerufDts.Beruf(1)
            rw.aDecimal = 8978.246D

      End Select
   End Sub

   Private Sub OutputPersonNachBeruf()
      Dim OutputLines As New List(Of String)()
      For Each rwBeruf As BerufRow In PersonBerufDts.Beruf
         OutputLines.Add(rwBeruf.bezeichnung & ": ")
         For Each rwoShortyo As PersonBerufRow In rwBeruf.GetPersonBerufRows()
            'Person-Namen eingerckt
            OutputLines.Add("     " & rwoShortyo.PersonRow.Name)
         Next
      Next
      MessageBox.Show(String.Join(Environment.NewLine, OutputLines.ToArray), "Person nach Beruf")
   End Sub

   Private Sub OutputBerufNachPerson()
      Dim OutputLines As New List(Of String)()
      For Each rwPerson As PersonRow In PersonBerufDts.Person
         OutputLines.Add(rwPerson.Name & ": ")
         For Each rwoShortyo As PersonBerufRow In rwPerson.GetPersonBerufRows()
            'Berufsbezeichnungen eingerckt
            OutputLines.Add("     " & rwoShortyo.BerufRow.bezeichnung)
         Next
      Next
      MessageBox.Show(String.Join(Environment.NewLine, OutputLines.ToArray), "Berufe nach Person")
   End Sub

   Private Function AllePersonenDieInPersonBerufVorkommen() As IEnumerable(Of PersonRow)
      'diese Krankheit gruppiert PersonBeruf nach PersonID und sammelt dann die dadurch bezeichneten PersonRows
      Return From rw In PersonBerufDts.PersonBeruf Group rw.PersonRow By rw.PersonID Into First() Select First
      'bessere Formulierung
      Return From rw In PersonBerufDts.Person Where rw.GetPersonBerufRows.Length > 0
   End Function

End Class